function F=epoint(M,sing_cons)
% F=epoint(M)
% M = 4xn -> (x,y,x',y')

if nargin==1, sing_cons=1;end


p1=M(:,1:2);
p2=M(:,3:4);

arg=1;
NoOfPoints=size(p1,1);

% Normalize pic1
ori=mean(p1);
sum=0;
for i=1:NoOfPoints,
    sum=sum+sqrt((p1(i,1)-ori(1))^2+(p1(i,2)-ori(2))^2);
end

par=sqrt(2)/(sum/NoOfPoints);

if arg==1,
    T1=[par 0   -ori(1)*par
        0   par -ori(2)*par
        0   0   1           ];
else    
    T1=eye(3);
end


temp=zeros(3,1);
for i=1:NoOfPoints,
	temp(1)=p1(i,1);
	temp(2)=p1(i,2);
	temp(3)=1;
	temp=T1*temp;
	pn1(i,1)=temp(1);
	pn1(i,2)=temp(2);
%    pn1(i,3)=temp(3);
end


% Normalize pic2
ori=mean(p2);
sum=0;
for i=1:NoOfPoints,
    sum=sum+sqrt((p2(i,1)-ori(1))^2+(p2(i,2)-ori(2))^2);
end

par=sqrt(2)/(sum/NoOfPoints);

if arg==1,
    T2=[par 0   -ori(1)*par
        0   par -ori(2)*par
        0   0   1           ];
else
    T2=eye(3);
end

temp=zeros(3,1);
for i=1:NoOfPoints,
	temp(1)=p2(i,1);
	temp(2)=p2(i,2);
	temp(3)=1;
	temp=T2*temp;
	pn2(i,1)=temp(1);
	pn2(i,2)=temp(2);
%    pn2(i,3)=temp(3);
end


% Linear solution

A(:,1)=pn1(:,1).*pn2(:,1);
A(:,2)=pn1(:,2).*pn2(:,1);
A(:,3)=pn2(:,1);
A(:,4)=pn1(:,1).*pn2(:,2);
A(:,5)=pn1(:,2).*pn2(:,2);
A(:,6)=pn2(:,2);
A(:,7)=pn1(:,1);
A(:,8)=pn1(:,2);
A(:,9)=1;

[U,S,V] = svd(A);

Ft(1,1)=V(1,9);
Ft(1,2)=V(2,9);
Ft(1,3)=V(3,9);
Ft(2,1)=V(4,9);
Ft(2,2)=V(5,9);
Ft(2,3)=V(6,9);
Ft(3,1)=V(7,9);
Ft(3,2)=V(8,9);
Ft(3,3)=V(9,9);

if (sing_cons==1),
    [U,S,V] = svd(Ft);


    S(3,3)=0;
    
    Ft=U*S*V';
end



F=T2'*Ft*T1;
F=F/norm(F);

%F=U*S*V';
